#******************************************************************************
# vO: P020303.R                                                     *
# eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *
# eLXg̐: R߁@pʔ                                        *
# gpړI: pʔ̗ᐔ߂iV~[VAo͋Ȑj        *
# Date: 2017/2/3  Version: 1.0                                                *
#******************************************************************************

# ----- o͐ݒ
sink("./p020303.txt")

# ----- ֐` ---- Cochran.Armitage
usr.Cochran.Armitage <- function(r.i, n.i, x.i=1:length(r.i))
{
	k <- length(r.i)
	p.i <- r.i/n.i
	p.m <- (r <- sum(r.i))/(n <- sum(n.i))
	xx <- x.i-(x.m <- sum(n.i*x.i)/n)
	b <- sum(n.i*(p.i-p.m)*xx)/sum(n.i*xx^2)
	a <- p.m-b*x.m

	xt <- b^2*sum(n.i*xx^2)/(p.m*(1-p.m))
	xh <- n^2*(sum(r.i^2/n.i)-r^2/n)/r/(n-r)
	xq <- xh-xt

	res <- matrix(c(xt, xq, xh, 1, k-2, k-1, 1-pchisq(xt, 1), 1-pchisq(xq, k-2), 1-pchisq(xh, k-1)), nrow=3)
	dimnames(res) <- list(c("Trend", "Quad.", "Homo."),c("Chi-sq.", "d.f.", "P value"))
	res

}

# ----- ֐` ----- V~[Vɂpʔ̗ᐔ݌v
#  ARGV   : eQ̗Li{,}ŗ񋓁j
#  ALPHA  : БLӐ(P̉ߌ)
#  N      : ᐔ
#  R      : V~[V
f020303 <- function(ARGV, ALPHA, N, R)
{
	N.P <- rbinom(R, N, ARGV[1])
	N.L <- rbinom(R, N, ARGV[2])
	N.M <- rbinom(R, N, ARGV[3])
	N.H <- rbinom(R, N, ARGV[4])
	N.mat <- rbind(N.P, N.L, N.M, N.H)
	Pr <- apply(N.mat, 2, function(x, n)usr.Cochran.Armitage(x,rep(n, 4))[1,3], n=N)
	POWER <- ifelse(Pr/2 < ALPHA, 1, 0)
	MEAN <- sum(POWER)/length(POWER)
	c(R=R,N=N,MEAN=MEAN)
}

s020303a10 <- f020303(ARGV=c(0.15, 0.25, 0.35, 0.35), ALPHA=0.025, N=10, R=1000)
s020303a20 <- f020303(ARGV=c(0.15, 0.25, 0.35, 0.35), ALPHA=0.025, N=20, R=1000)
s020303a30 <- f020303(ARGV=c(0.15, 0.25, 0.35, 0.35), ALPHA=0.025, N=30, R=1000)
s020303a40 <- f020303(ARGV=c(0.15, 0.25, 0.35, 0.35), ALPHA=0.025, N=40, R=1000)
s020303a50 <- f020303(ARGV=c(0.15, 0.25, 0.35, 0.35), ALPHA=0.025, N=50, R=1000)
s020303a60 <- f020303(ARGV=c(0.15, 0.25, 0.35, 0.35), ALPHA=0.025, N=60, R=1000)
s020303a70 <- f020303(ARGV=c(0.15, 0.25, 0.35, 0.35), ALPHA=0.025, N=70, R=1000)
s020303a80 <- f020303(ARGV=c(0.15, 0.25, 0.35, 0.35), ALPHA=0.025, N=80, R=1000)
s020303a90 <- f020303(ARGV=c(0.15, 0.25, 0.35, 0.35), ALPHA=0.025, N=90, R=1000)
s020303a100 <- f020303(ARGV=c(0.15, 0.25, 0.35, 0.35), ALPHA=0.025, N=100, R=1000)

s020303aall <- rbind(s020303a10,s020303a20,s020303a30,s020303a40,s020303a50,
				s020303a60,s020303a70,s020303a80,s020303a90,s020303a100)
row.names(s020303aall)<-1:10
print(s020303aall)
# ----- o͐Wɖ߂
sink()
